#if !defined ( __OBJECTIVE_FUNCTION__ )
#define        __OBJECTIVE_FUNCTION__

#include<stdio.h>
#include "general.h"

class objective_function
{
    public:
        int Dim;
        p_double *Domain;
        double *optimum;
        double precision;
        char *outfile;
        char name[256];
        int Return_to_domain;

        objective_function ( void )
        {
            Dim=0;
            Domain=NULL;
            optimum=NULL;
            outfile=NULL;
            precision=0.0;
            Return_to_domain=0;
        };
        virtual ~objective_function ( void )
        {
            int i;
            for ( i=0; i<Dim; i++ ) delete [] Domain[i];
            delete [] Domain;
            delete optimum;
        };
        virtual void create ( void )
        {
        };
        virtual double value ( double *oCH )=0;
        virtual void evaluate ( double *oCH )
        {
        };
        virtual void evaluate ( double *oCH, int call, double value )
        {
        };
};

#endif

/*
author: Anicka Kucerova, Czech Technical University in Prague
version 0.0.1
16 Mar 2009
*/
