#if !defined ( __GRADE__ ) 
#define        __GRADE__ 
 
#if !defined ( __OBJECTIVE_FUNCTION__ ) 
#include "function.h" 
#endif 
 
#include <math.h> 
#include <string.h> 

class grade 
{ 
    public: 
        grade ( void ); 
        ~grade ( void ); 
        void run ( void ); 
        void create ( void ); 
	void clear ( void ); 
        int vilog; 
        int fitness_calls_limit; 
        int pool_rate, fitness_call; 
        double radioactivity; 
        double cross_limit; 
        objective_function *F; 
	double *bsf, bsf_value; 
 
    private: 
        void new_point ( double *x ); 
        void EVALUATE_GENERATION ( int start ); 
        void SELECT ( void ); 
        void MUTATE ( void ); 
        void CROSS ( void ); 
        void FIRST_GENERATION ( void); 
        void clear_pool ( void ); 
        int to_continue (); 
 
        int vilog_news ( void ); 
        void vilog_results (); 
        void vilog_make_out (); 

        int ActualSize, generation, PoolSize, SelectedSize; 
        double *Force; 
        int *origine, btg_or; 
        p_double *CH; 
 
        double *btg, btg_value, sbtg; 
        int bsf_birth; 
}; 

#endif

/*
author: Anicka Kucerova, Czech Technical University in Prague
version 0.0.1
19 Mar 2009
*/
