#include "general.h"

#include <sys/time.h>
#include <unistd.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

int rseed=-1;

void initialize_randoms ( void )
{
    if ( rseed==-1 )
    {
        struct timeval tv ;
        struct timezone tz ;
        gettimeofday( &tv,&tz ) ;
        rseed=tv.tv_usec+( tv.tv_sec%4194304 )*1000 ;

        FILE *f;
        f=fopen("rseed", "wt");
        fprintf ( f, "%d", rseed );
        fclose ( f );
    }
    srand( rseed ) ;
}

int random_int ( int olow , int ohigh )
{
    return rand()%( ohigh-olow+1 )+olow ;
}

double random_double ( double olow , double ohigh )
{
    return (( double )rand()/RAND_MAX )*( ohigh-olow )+olow ;
}

/*
author: Anicka Kucerova, Czech Technical University in Prague
version 0.0.1
16 Mar 2009
*/

