#if !defined ( __GRADE__ ) 
#include "grade.h"
#endif 
 
#include <stdio.h> 
 
int grade::vilog_news ( void ) 
{ 
    if ( !vilog ) return 1; 
 
    printf( "fc=%d   BTG=%.10g   BSF=%.10g\n", fitness_call, btg_value, bsf_value) ; 
    return 1; 
} 
 
void grade::vilog_results () 
{ 
    if ( !vilog ) return; 
 
    int i; 
    
    printf( "\nfc=%d   BSF=%.10g bsf_birth=%d", fitness_call, bsf_value, bsf_birth ) ; 
    printf ( "\nx=( %.5g",bsf[0] ); 
    for ( i=1; i<F->Dim; i++ ) printf ( ", %.5g", bsf[i] ); 
    printf ( " )\n" ); 
} 
 
void grade::vilog_make_out () 
{ 
    if ( !vilog ) return; 
 
    int i; 
    char file[32]; 
 
    FILE *f; 
 
    if ( F->outfile ) f = fopen ( F->outfile, "at" ); 
    else f = fopen ( "results", "at" ); 
 
    fprintf ( f, "%d\t%.10g\t%d\t", fitness_call, bsf_value, bsf_birth ); 
    if ( F->optimum ) fprintf ( f, "%.5g\t", fabs(*F->optimum-bsf_value) ); 
    for ( i=0; i<F->Dim; i++ ) fprintf ( f, "%.5g\t", bsf[i] ); 
    fprintf ( f, "\n" ); 
    fclose ( f ); 
} 

/*
author: Anicka Kucerova, Czech Technical University in Prague
version 0.0.1
19 Mar 2009
*/
 

 
